package org.processmininguc.configurableprocesses.algorithms;

import java.util.Map;

import org.processmining.plugins.etm.fitness.TreeFitness;
import org.processmining.plugins.etm.model.narytree.Configuration;

public class ConfigurableProcessesResult {
	private String timeElapsed;
	private double conformance;
	private Configuration bestConfiguration;
	private TreeFitness overallFitnessMetric;
	private double fitness;
	private double precision;
	private double generalization;
	private double simplicity;
	private int paramFitness;
	private int paramPrecision;
	private int paramGeneralization;
	private int paramSimplicity;
	private Map<String,String> finalConf;
	private int configurationSize;
	
	public ConfigurableProcessesResult(){
		timeElapsed = "0";
		conformance = 0;
		bestConfiguration = null;
		overallFitnessMetric = null;
	}
		
	/* Getters */
	public int getConfigurationSize(){
		return configurationSize;
	}
	
	public Map<String,String> getFinalConf(){
		return finalConf;
	}
	
	public int getParamFitness(){
		return paramFitness;
	}
	
	public int getParamPrecision(){
		return paramPrecision;
	}

	public int getParamGeneralization(){
		return paramGeneralization;
	}

	public int getParamSimplicity(){
		return paramSimplicity;
	}

	public String getTimeElapsed(){
		return timeElapsed;
	}
	
	public double getConformance(){
		return conformance;
	}
	
	public Configuration getBestConfiguration(){
		return bestConfiguration;
	}
	
	public TreeFitness getOveralFitnessMetric() {
		return overallFitnessMetric;
	}

	public double getFitness(){
		return fitness;
	}
		
	public double getPrecision(){
		return precision;
	}

	public double getGeneralization(){
		return generalization;
	}

	public double getSimplicity(){
		return simplicity;
	}

	/* Setters */
	public void setConfigurationSize(int confSize){
		this.configurationSize = confSize;
	}
	
	public void setFinalConf(Map<String,String> finalConfiguration){
		this.finalConf = finalConfiguration;
	}
	
	public void setParamFitness(int f){
		this.paramFitness = f;
	}

	public void setParamPrecision(int p){
		this.paramPrecision = p;
	}

	public void setParamGeneralization(int g){
		this.paramGeneralization = g;
	}
	
	public void setParamSimplicity(int s){
		this.paramSimplicity = s;
	}
	
	public void setBestConfiguration(Configuration bestConfig){
		this.bestConfiguration = bestConfig;
	}
	
	public void setConformance(Double conformance){
		this.conformance = conformance;
	}

	public void setOveralFitnessMetric(TreeFitness overallFitnessMetric) {
		this.overallFitnessMetric = overallFitnessMetric;
	}
	
	public void setTimeElapsed(String time){
		this.timeElapsed = time;
	}

	public void setFitness(double f){
		this.fitness = f;
	}
	public void setPrecision(double p){
		this.precision = p;
	}
	public void setGeneralization(double g){
		this.generalization = g;
	}
	public void setSimplcity(double s){
		this.simplicity = s;
	}

}
