package org.processmininguc.configurableprocesses.algorithms;

import java.util.ArrayList;
import java.util.List;

import org.jgap.BaseGene;
import org.jgap.Gene;
import org.jgap.InvalidConfigurationException;
import org.jgap.RandomGenerator;
import org.jgap.UnsupportedRepresentationException;

public class ProcessTreeConfigurationOptionGene extends BaseGene{

	private static final long serialVersionUID = 1L;
	
	private Byte value;
	private List<Byte> options;
	
	public ProcessTreeConfigurationOptionGene(org.jgap.Configuration JGAPConfiguration, 
			List<Byte> options) throws InvalidConfigurationException {
		super(JGAPConfiguration);
		this.options = new ArrayList<Byte>(options);
	}

	//this function has changed from original implementation
	//return statement was originally:  return value.compareTo( ( (ProcessTreeConfigurationOptionGene) o ).value );
	public int compareTo(Object o) {
		int val=-2;
        if( o == null ) {
            return 1;
        }

        if( value== null ){
            if ( ((ProcessTreeConfigurationOptionGene) o).value == null ){
                val = 0;
            }
            else {
                val =  -1;
            }
        }

        return val;
	}
	
	public boolean equals( Object gene ) {
        return gene instanceof ProcessTreeConfigurationOptionGene && compareTo( gene ) == 0;
    }
	
	public int hashCode() {
        if (value == null) return 0;
        else return value.hashCode();
    }

	public void applyMutation(int index, double percentage) {
		int randomInt = this.getConfiguration().getRandomGenerator().nextInt(this.options.size());
		Byte randomOption = options.get(randomInt);
		setAllele(randomOption);
		
	}

	public String getPersistentRepresentation() throws UnsupportedOperationException {
		throw new UnsupportedOperationException("Not Implemented Yet");
	}

	public void setAllele(Object value) {
		this.value = (Byte) value;
		
	}
	
	public Object getAllele() {
		return this.value;
	}
	
	public void cleanup()
    {
        // There's no cleanup necessary for this implementation.
        // -----------------------------------------------------
    }

	public void setToRandomValue(RandomGenerator generator) {
		int randomInt = generator.nextInt(this.options.size());
		Byte randomOption = options.get(randomInt);
		this.value = randomOption;	
	}

	public void setValueFromPersistentRepresentation(String arg0) throws UnsupportedOperationException,
			UnsupportedRepresentationException {
		throw new UnsupportedOperationException("Not Implemented Yet");	
	}

	protected Object getInternalValue() {
		return value;
	}

	protected Gene newGeneInternal() {
		try {
	        return new ProcessTreeConfigurationOptionGene(getConfiguration(), options);
	    } 
		catch (InvalidConfigurationException ex) {
	        throw new IllegalStateException(ex.getMessage());
	    }
	}
}
	
	