package org.processmininguc.configurableprocesses.connections;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.processtree.ProcessTree;
import org.processmininguc.configurableprocesses.parameters.ExhaustiveParameters;

public class ExhaustiveConnection extends AbstractConnection {

	/**
	 * Label for first input.
	 */
	public final static String TREE = "Configurable Process Tree";
	
	/**
	 * Label for second input.
	 */
	public final static String LOG = "Log";
	
	/**
	 * Label for output.
	 */
	public final static String OUTPUT = "Output";

	/**
	 * Private copy of parameters.
	 */
	private ExhaustiveParameters parameters;

	/**
	 * Create a connection.
	 * @param input1 First input.
	 * @param input2 Second input.
	 * @param output Output.
	 * @param parameters Parameters.
	 */
	public ExhaustiveConnection(ProcessTree tree, XLog log, ProcessTree output, ExhaustiveParameters parameters) {
		super("Your Connection");
		put(TREE, tree);
		put(LOG, log);
		put(OUTPUT, output);
		this.parameters = new ExhaustiveParameters(parameters);
	}

	/**
	 * 
	 * @return The parameters stored in the connection.
	 */
	public ExhaustiveParameters getParameters() {
		return parameters;
	}
}
