package org.processmininguc.configurableprocesses.parameters;

import org.deckfour.xes.model.XLog;
import org.processmining.basicutils.parameters.impl.PluginParametersImpl;
import org.processmining.processtree.ProcessTree;

public class ExhaustiveParameters extends PluginParametersImpl {

	private boolean verbose;
	private String resultName;
	public int fitnessWeigth, precisionWeigth, generalizationWeigth, simplicityWeigth;
	
	public ExhaustiveParameters(ProcessTree tree, XLog log) {
		super();
		setVerbose(false);
		setTryConnections(false);
		setResultName("Configuration for "+tree.getName());
		fitnessWeigth = 90;
		precisionWeigth = 10;
		generalizationWeigth = 0;
		simplicityWeigth = 0;
	}

	public ExhaustiveParameters(ExhaustiveParameters parameters) {
		super(parameters);
		setVerbose(parameters.isVerbose());
		setResultName(parameters.getResultName());
		setTryConnections(parameters.isTryConnections());
	}
	
	public boolean equals(Object object) {
		if (object instanceof ExhaustiveParameters) {
			ExhaustiveParameters parameters = (ExhaustiveParameters) object;
			return super.equals(parameters) &&
					isVerbose() == parameters.isVerbose() &&
					getResultName().equals(parameters.getResultName());
		}
		return false;
	}
	
	public boolean isVerbose() {
		return verbose;
	}

	public void setVerbose(boolean verbose) {
		this.verbose = verbose;
	}

	public String getResultName() {
		return resultName;
	}

	public void setResultName(String resultName) {
		this.resultName = resultName;
	}

	public String toString() {
		return "(" + getResultName() + "," + isVerbose() + ")";
	}
	
	//new initial Conformance parameters
	public void setFitnessWeigth(int fitness){
		this.fitnessWeigth = fitness;
	}
		
	public void setPrecisionWeigth(int precision){
		this.precisionWeigth = precision;
	}
		
	public void setGeneralizationWeigth(int generalization){
		this.generalizationWeigth = generalization;
	}

	public void setSimplicityWeigth(int simplicity){
		this.simplicityWeigth = simplicity;
	}

	public int getFitnessWeigth(){
		return fitnessWeigth;
	}

	public int getPrecisionWeigth(){
		return precisionWeigth;
	}

	public int getGeneralizationWeigth(){
		return generalizationWeigth;
	}

	public int getSimplicityWeigth(){
		return simplicityWeigth;
	}
}
